--[[

TorghastStats Addon.
@author Ben Antonellis
@ign Jimlee-Borean Tundra
@version 1.0
@date November 26th, 2020
@license MIT -  See CurseForge / Github

*******************************
*THIS IS AN OLD IMPLEMENTATION*
*******************************

]]--

local addonName = "TorghastStats"
local PHANTASMA_ID_NUMBER = 1728
local debug = false

--[[

Main event trigger function. This is the callback passed to the onEvent
script. This function handles each event, and calls the necessary function
that corresponds to each event.

]]--
local function eventTrigger(self, event, ...)

	local mapID = C_Map.GetBestMapForUnit("player")
	local zone = C_Map.GetMapInfo(mapID).name

	if (event == "PLAYER_CHOICE_UPDATE") and (zone == "Torghast") then
		newAnimaOrb()
	end

	-- Check for addon load
	if event == "ADDON_LOADED" then
		if zone == "Torghast" then
			print("|cFFC7BF50<|cFF50C79F" .. addonName .. " Loaded!|cFFC7BF50>|r")
			local default = {
				Phantasma = 0,
				TotalPhantasma = 0,
				Mawrats = 0,
				AnimaOrbs = 0,
				JarsBroken = 0,
				FloorsCompleted = 0
			}
			local TorghastData = _G['TorghastData'] or default
		else
			logout()
		end
	end

	-- Check for player logout to save variables
	if event == "PLAYER_LOGOUT" then
		logout()
	end

	-- Check for new phantasma updates, looted or spent
	if event == "CURRENCY_DISPLAY_UPDATE" then
		currencyType, quantity, quantityChange, quantityGainSource, quantityLostSource = ...
		newPhantasma(currencyType, quantity, quantityChange, quantityGainSource, quantityLostSource)
	end

end

--[[

Function to save the current table to the global saved variables.

TODO: Rename function since it isn't only used when the user wants to log out.

]]--
local function logout()

	TorghastData.TotalPhantasma = TorghastData.TotalPhantasma + TorghastData.Phantasma
	TorghastData.Phantasma = 0

	_G['TorghastData'] = TorghastData

end

--[[

Function to handle adding new phantasma to the
table. Provides debug functionalityif the user
wants to see everything happening. Also helps
for finding bugs.

]]--
local function newPhantasma(currencyType, quantity, quantityChange, quantityGainSource, quantityLostSource)

	if debug then

		print("Currency Type: " .. currencyType)
		print("Quantity: " .. quantity)
		print("Quantity Change: " .. quantityChange)
		print("Quantity Gain Source: " .. quantityGainSource)
		print("Quantity Lost Source: " .. quantityLostSource)

		print("|cFFC7BF50Current Phantasma: " .. Phantasma .. "!|r")

	end

	if currencyType == PHANTASMA_ID_NUMBER then
		if quantity < TorghastData.Phantasma then
			TorghastData.Phantasma = quantity
		else
			TorghastData.Phantasma = TorghastData.Phantasma + quantityChange
		end
	end

end

--[[

Functions to implement.

]]--
local function newMawrat(...) end
local function newAnimaOrb(...) end
local function newJarBroken(...) end
local function newFloorComplete(...) end

--[[

Callback function for handing slash commands.

TODO: Add more stats to be printed.

]]--
local function torghastCommands(msg, editbox) --  the fuck is an editbox?

	if msg == "stats" then
		print("|cFFC7BF50Total Phantasma Earned: " .. TorghastData.TotalPhantasma)
		print("|cFFC7BF50Mawrats Killed: " .. TorghastData.Mawrats)
		print("|cFFC7BF50Anima Orbs Collected: " .. TorghastData.AnimaOrbs)
		print("|cFFC7BF50Jars Broken: " .. TorghastData.JarsBroken)
		print("|cFFC7BF50Floors Completed: " .. TorghastData.FloorsCompleted)
	end

end

SLASH_TORGHASTSTATS1 = '/tgs'
SlashCmdList['TORGHASTSTATS'] = torghastCommands

local f = CreateFrame('Frame')
f:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
f:RegisterEvent("PLAYER_LOGOUT")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_CHOICE_UPDATE")
f:SetScript("OnEvent", eventTrigger)